#include <stdio.h>
#include <conio.h>
#include "../list_rom.h"

FILE *O,*B,*F;
char already_tested[NB_ROM];
char possible_name[63];
char possible_name_size;
int  *nb_rom_of_file;
int nb_unknown = 0;
int total_nb = 0;

/*****************************************************************************

    Function: write_info

    Description: write info concerning the file named name
    Parameters: name is the char* of the file
    Return: number of rom on success else -1

*****************************************************************************/


int write_info(char* name)
 {
  unsigned CRC=CRC_file(name);
  unsigned i;

  for (i=0;i<NB_ROM ;i++ )
     {
      if (CRC==ROM_LIST[i].CRC)
        {
          fprintf(O,"    ROM NAME : %s\n   GAME NAME : %s\n         CRC : 0X%X\nRELEASE DATE : %s\n      SERIAL : %s\n     COMMENT : %s\n",
                  name,
                  (ROM_LIST[i].name[0]?ROM_LIST[i].name:"NONE"),
                  ROM_LIST[i].CRC,
                  (ROM_LIST[i].date[0]?ROM_LIST[i].date:"NONE"),
                  (ROM_LIST[i].serial[0]?ROM_LIST[i].serial:"NONE"),
                  (ROM_LIST[i].note[0]?ROM_LIST[i].note:"NONE"));
          if (ROM_LIST[i].flags&SUPER_GRAPHX)
            fprintf(O,"  SUPERGRAPHX GAME\n");
          if (ROM_LIST[i].flags&PINBALL_KEY)
            fprintf(O,"  GAME WITH PINBALL KEY MAPPING\n");
          if (ROM_LIST[i].flags&USA)
            fprintf(O,"           US GAME\n");
          if (ROM_LIST[i].flags&JAP)
            fprintf(O,"     JAPANESE GAME\n");
          fprintf(O,"\n");
          return i;
        }
     }

  //fprintf(O,"ROM NAME : %s\nTHIS GAME IS UNKNOWN\nPLEASE CONTACT US\n\n",name);


  return -1;
  }

int main(int argc, char *argv[])
{
    unsigned i,j;

    if (!(O=fopen("ROM_LIST.TXT","wt")))
      return;

    if (!argc)
      return -2;
    if (!(nb_rom_of_file=(int*)(alloca((argc-1)*sizeof(int)))))
         return -1;

    memset(already_tested,0,NB_ROM);
    memset(nb_rom_of_file,0,(argc-1)*sizeof(int));

    for (i=1;i<argc ; i++)
       {
        strupr(argv[i]);
        printf("TESTING %s",argv[i]);
        nb_rom_of_file[i]=write_info(argv[i]);

        if (nb_rom_of_file[i]==-1)
         {
          nb_unknown++;
          printf("  UNKNOWN!!\n");
         }
        else
         {
          if (!(already_tested[nb_rom_of_file[i]]))
            total_nb++;
          already_tested[nb_rom_of_file[i]]=1;
          printf("   OK\n");
         }
       }

    if (nb_unknown)
      {
         printf("\nSECOND CHECKSUMMING...");
         for (j=1;j<argc ; j++)
           {
             if (nb_rom_of_file[j]==-1)
                if ((nb_rom_of_file[j]=write_info(argv[j]))!=-1)
                   nb_unknown--;
           }
      }


    if (nb_unknown)
      {
       printf("\nTESTING UNKNOWN ROMS...");
       printf("%i UNKNOWN ROM(S)\n",nb_unknown);
       for (j=1;j<argc ; j++)
          {
           if (nb_rom_of_file[j]==-1)
            {
             fprintf(O,"\n%s IS UNKNOWN, MAYBE DAMAGED, PLEASE CONTACT US!!\n",argv[j]);
             fprintf(O,"CRC IS : 0X%X\n",CRC_file(argv[j]));
             if (!(F=fopen(argv[j],"rb")))
               exit (-1);
             i=filesize(F) & 0x00000FFF;
             if (i==0x200)
               {
                fprintf(O,"BUT CORRECT HEADER FOUND\n");
                fseek(F,0x1C0,SEEK_SET);
                fread(&possible_name_size,1,1,F);
                possible_name_size=(62>possible_name_size?possible_name_size:62);
                fseek(F,0x1C2,SEEK_SET);
                memset(possible_name,0,63);
                fread(possible_name,1,possible_name_size,F);
                fprintf(O,"POSSIBLE NAME : %s\n",possible_name);

                }
              else
                fprintf(O,"BUT WITHOUT CORRECT HEADER...\n");

             fclose(F);
            }
          }
      }
    else
      {
       fprintf(O,"\nGOOD, NO UNKNOWN ROMS.\n");
       printf("\nNO UNKNOWN ROMS.\n");
      }



    printf("TESTING DUPLICATED ROMS...");

    if (!(B=fopen("CLEAN.BAT","wt")))
      exit (-1);

    fprintf(B,"REM BATCH FILE GENERATED BY FPCEID\n\n");

    for (i=0;i<NB_ROM ; i++)
       {
        int nb_of_this_rom = 0;
        if (!(already_tested))
          continue;

        for (j=1;j<argc ; j++)
             nb_of_this_rom+=(i==nb_rom_of_file[j]);

        if (nb_of_this_rom>1)
          {
           fprintf(O,"/***** DANGER *******************************************************\n");
           fprintf(O,"You're overbloating your hard disk with %i copies of a same game : \n",nb_of_this_rom);
           j=1;
           while (i!=nb_rom_of_file[j++]) ;
           fprintf(O,"  -> %s\n",argv[j-1]);

           for ( ;j<argc ; j++)
              if (i==nb_rom_of_file[j])
                {
                  fprintf(O,"  -> %s\n",argv[j]);
                  fprintf(B,"  DEL %s\n",argv[j]);
                }
           fprintf(O,"/********************************************************************\n");
           }
       }

    fclose(B);


  if (!(B=fopen("WANTED.TXT","wt")))
    exit (-1);

  if (total_nb==NB_ROM)
    fprintf(B,"AAAAAARGH!!\nWHAT DO YOU WANT I PUT THERE ;)\nGAME OVER.\n");
  else
    {
      fprintf(B,"YOU'VE ONLY MISSED %i ROMS\n\n",NB_ROM-total_nb);
      for (i=0;i<NB_ROM ; i++)
         {
          if (already_tested[i])
            continue;
          fprintf(B,"%s   CRC:0X%X\n",ROM_LIST[i].name,ROM_LIST[i].CRC);
         }
    }
  fclose(B);
  fclose(O);
  printf("\nFINISHED!!\n");
  return 0;
}
